; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; boolean?

; ---conformance---
; R5RS

; ---purpose---
; Check whether an expression
; .V x
; is a truth value. Return
; .C #t
; for
; .V x
; =
; .C #t
; and
; .V x
; =
; .C #f
; and otherwise
; .C #f.

; ---args---
; X - expression

; ---keywords---
; BOOLEAN? function, boolean, truth value, true, false
; predicate

; ---see-also---
; list?, null?

; ---example---
; (boolean? #f) => #t

(define booleanp #t)

; ---code---
(define (boolean? x)
  (or (eq? x #t)
      (eq? x #f)))

