; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; even?

; ---conformance---
; R5RS

; ---purpose---
; Test a number
; .V n
; for being even
; .V (n modulo 2 = 0).

; ---args---
; X - number

; ---keywords---
; EVEN? function, even, odd, numbers, digit, predicate

; ---see-also---
; digits, odd?, zero?

; ---example---
; (even? 2) => #t

(define evenp #t)

(require "digits.scm")
(require "reverse.scm")
(require "neqp.scm") ; neq?
(require "memq.scm")
; (require "zerop.scm") ; zero?
; (require "remainder.scm")

; ---model---
; (define (even? x)
;   (zero? (remainder x 2)))

; ---code---
(define (even? x)
  (neq? (memq (car (reverse (integer->list x)))
              (integer->list 02468))
        #f))

