; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; >=

; ---conformance---
; R5RS

; ---purpose---
; Check whether two or more numbers are in non-ascending order.
; Return
; .C #t,
; if
; .V a>=b>=...
; and otherwise
; .C #f.

; ---args---
; A - number
; B... - numbers

; ---keywords---
; >= function, not less than, greater than or equal to,
; ordering, relation, comparison, predicate

; ---see-also---
; digits, <, >, <=, n>=

; ---example---
; (>= 4 4 3) => #t

(define gteq #t)

(require "less.scm") ; <
(require "reduce.scm")
(require "neqp.scm") ; neq?

; ---code---
(define (>= a . b)
  (letrec
    ((gteq (lambda (a b)
      (cond ((eq? a #t) #t)
        ((< a b) #t)
        (#t b)))))
    (cond ((null? b)
        (bottom '(too few arguments to >=)))
      (#t (neq? (reduce gteq (cons a b) #f)
                #t)))))

