; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; n>=

; ---conformance---
; SketchyLISP Core

; ---purpose---
; Check if two natural numbers are in non-ascending
; order. Return
; .C #t,
; if
; .V a>=b
; and otherwise
; .C #f.

; ---args---
; A - natural number
; B - natural number

; ---keywords---
; N>= function, not less than, greater than or equal to,
; ordering, relation, comparison, predicate, natural

; ---see-also---
; digits, n>, n<=, =, >=

; ---example---
; (n>= 7 5) => #t

(define ngteq #t)

; ---code---
(define (n>= a b)
  (eq? (n< a b) #f))

