; SketchyLISP Library
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; odd?

; ---conformance---
; R5RS

; ---purpose---
; Test a number
; .V n
; for being odd
; .V (n modulo 2 = 1).

; ---args---
; X - number

; ---keywords---
; ODD? function, odd, even, numbers, digit, predicate

; ---see-also---
; digits, even?, zero?

; ---example---
; (odd? 3) => #t

(define oddp #t)

(require "digits.scm")
(require "reverse.scm")
(require "memq.scm")
(require "neqp.scm") ; neq?
; (require "evenp.scm") ; even?

; ---model---
; (define (odd? x)
;   (not (even? x)))

; ---code---
(define (odd? x)
  (neq? (memq (car (reverse (integer->list x)))
              (integer->list 13579))
        #f))

