; SketchyLISP Example Program
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; count

; ---conformance---
; R5RS

; ---purpose---
; Recursively count the atoms of a list.
; Members of all sublists are included.

; ---args---
; X - list

; ---keywords---
; COUNT function, list, member, size

; ---example---
; (count '(a b (c (d) e) ((f)))) => 6

(define count #t)

; (require "nplus.scm") ; n+

; ---code---
(define (count x)
   (cond ((null? x) 0)
     ((pair? x)
       (n+ (count (car x))
           (count (cdr x))))
     (#t 1)))

