; SketchyLISP Example Program
; Copyright (C) 2005,2006 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; fact

; ---conformance---
; R5RS

; ---purpose---
; Compute
; .V x!
; using the "recursive product" algorithm.
; .V X
; must be a positive integer.
; .P
; The algorithm (in Java) was found under
; "factorial functions" at
; .C http://www.luschny.de/math/.

; ---args---
; N - number

; ---keywords---
; FAC function, factorial

; ---example---
; (fact 5) => 120

; (require "lib/digits.scm")
; (require "lib/zerop.scm") ; zero?
; (require "lib/negativep.scm") ; negative?

; ---model---
(define (fact n) 
  (cond ((zero? n) 1)
    (#t (* n (fact (- n 1))))))

; ---code---
(define (fact n)
  (letrec
    ((r* (lambda (n k)
      (cond ((< k 2) n)
        (#t (let ((l (quotient k 2)))
              (* (r* n l)
                 (r* (+ n l) (- k l)))))))))
    (cond ((negative? n)
        (bottom (list 'fact n)))
      (#t (r* 1 n)))))

