; SketchyLISP Example Program
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; head?

; ---conformance---
; R5RS

; ---purpose---
; Check whether an expression
; .V x
; is the head of an
; expression
; .V y.

; ---args---
; X - potential head
; Y - expression

; ---keywords---
; HEAD? function, list, pair, head

; ---example---
; (head? '(a b c) '(a b c d e f)) => #t

; (require "lib/equalp.scm") ; equal?

; ---code---
(define (head? x y)
  (cond ((null? y) (null? x))
    ((null? x) #t)
    ((equal? (car x) (car y))
      (head? (cdr x) (cdr y)))
    (#t #f)))

