; SketchyLISP Example Program
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; product

; ---conformance---
; SketchyLISP

; ---purpose---
; Compute the product of a sequence of
; positive numbers.

; ---args---
; N - least value of sequence
; M - maximum value of seqence

; ---keywords---
; PRODUCT function, product of sequence

; ---example---
; (product 5 7) => 210

(define product #t)

; (require "lib/digits.scm")
; (require "lib/equal.scm") ; =
; (require "lib/ngreater.scm") ; n>
; (require "lib/ntimes.scm") ; n*
; (require "lib/natural.scm")

; ---model---
; (define (product n m)
;   (cond ((= n m) m)
;     (#t (n* n (product (n+ n 1) m)))))

; ---code---
(define (product n m)
  (letrec
    ((nn (natural n))
    (lim (natural m))
    (prod (lambda (n r)
      (cond ((n> n lim) r)
        (#t (prod (n+ n 1) (n* n r)))))))
    (cond ((n> nn lim)
        (bottom 'product-range))
      (#t (prod nn 1)))))

