; SketchyLISP Example Program
; Copyright (C) 2005,2006 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; sublist

; ---conformance---
; R5RS

; ---purpose---
; Substitute variables in S-expressions.
; For a description of association lists (alists)
; see ASSOC.

; ---args---
; A - alist with bindings
; X - S-expression to process

; ---keywords---
; SUBLIST function, substitution, substitute variables
; association lists

; ---example---
; (sublist '((i . 1) (ii . 2) (iii . 3)) '(i + ii - iii)) => (1 + 2 - 3)

; (require "lib/assoc.scm")
; (require "lib/reverse.scm")
; (require "lib/caar.scm") ; cdar
; (require "lib/append.scm")

; ---code---
(define (sublist a x)
  (cond ((null? x) '())
    ((pair? x)
      (cons (sublist a (car x))
            (sublist a (cdr x))))
    (#t (let ((r (assoc x a)))
          (cond (r (cdr r))
            (#t x))))))

