; SketchyLISP Example Program
; Copyright (C) 2005,2006 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; sum

; ---conformance---
; R5RS

; ---purpose---
; Compute the sum of a sequence of positive numbers.

; ---args---
; N - least value of sequence
; M - maximum value of seqence

; ---keywords---
; SUM function, sum of sequence

; ---example---
; (sum 2 5) => 14

(define sum #t)

; (require "lib/digits.scm")
; (require "lib/equal.scm") ; =
; (require "lib/ngreater.scm") ; n>
; (require "lib/natural.scm")
; (require "lib/ntimes.scm") ; n*
; (require "lib/nquotient.scm")

; ---model---
; (define (sum n m)
;   (cond ((= n m) m)
;     (#t (n+ n (sum (n+ n 1) m)))))

; ---code---
(define (sum n m)
  (letrec
    ((nn (natural n))
    (nm (natural m))
    (_sum (lambda (n m)
      (let ((x (n+ 1 (n- m n))))
        (n+ (nquotient (n+ (n* x x) x)
                       2)
            (n* (n- n 1) x))))))
    (cond ((n> nn nm)
        (bottom 'sum-range))
      (#t (_sum nn nm)))))

