; SketchyLISP Example Program
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; tail?

; ---conformance---
; SketchyLISP Extension

; ---purpose---
; Check if an expression
; .V x
; is the tail of an expression
; .V y.

; ---args---
; X - potential tail
; Y - expression

; ---keywords---
; TAIL? function, list, pair, tail

; ---example---
; (tail? '(d e f) '(a b c d e f)) => #t

; (require "lib/equalp.scm") ; equal?

; ---model---
; (define (tail? x y)
;   (cond ((null? y) (null? x))
;     ((equal? x y) #t)
;     (#t (tailp x (cdr y)))))

; ---code---
(define (tail? x y)
  (letrec
    ((tailp (lambda (y)
      (cond ((null? y) (null? x))
        ((equal? x y) #t)
        (#t (tailp (cdr y)))))))
    (tailp y)))

