; SketchyLISP Example Program
; Copyright (C) 2005 Nils M Holm. All rights reserved.
; See the file LICENSE of the SketchyLISP distribution
; for conditions of use.

; ---name---
; union

; ---conformance---
; SketchyLISP

; ---purpose---
; Compute the union of two sets.
; Sets are represented by lists
; of unique members.

; ---args---
; A - set
; B - set

; ---keywords---
; UNION function, union, sets, set theory

; ---example---
; (union '(a b c) '(b d)) => (a b c d)

(define union #t)

(require "unique.scm")
; (require "lib/append.scm")
; (require "lib/reverse.scm")
; (require "lib/member.scm")

; ---model---
; (define (union a b)
;   (cond ((null? a) b)
;     ((member (car a) b) (union (cdr a) b))
;     (#t (cons (car a) (union (cdr a) b)))))

; ---code---
(define (union a b)
  (unique (append a b)))

